<?php

namespace XenGenTr\ResimliOneCikanKonular\Entity;

use XF\Mvc\Entity\Structure;

class OneCikan extends \XF\Mvc\Entity\Entity
{
	public function canEdit()
	{
		$thread = $this->Thread;
		$visitor = \XF::visitor();
		
        if ($visitor->canOnecikanYonet())
		{
			return true;
		}
		
        if ($visitor->canOnecikarabilir()
			&& $visitor->user_id == $thread->user_id)
		{
			return true;
		}
		
		return false;
	}
	
	public function getImage()
	{
		$image = \XF::getRootDirectory() . '/data/XenGenTr/xengentr_resimlikonular/' . $this->thread_id . '.jpg';
		
		if (file_exists($image))
		{
			return $this->app()->applyExternalDataUrl('XenGenTr/xengentr_resimlikonular/' . $this->thread_id . '.jpg?' . $this->onecikan_zaman, true);
		}
	
		return "styles/XenGenTr/XGTOnecikanKonular/_onecikan-min.png";
	}
	
	protected function _preSave()
	{
		$this->onecikan_zaman = \XF::$time;
	}
	
	protected function _postDelete()
	{
		\XF\Util\File::deleteFromAbstractedPath('data://XenGenTr/xengentr_resimlikonular/'.$this->thread_id.'.jpg');
	}
	
	public static function getStructure(Structure $structure)
	{
		$structure->table = 'xgt_onecikan_konular';
		$structure->shortName = 'XenGenTr\ResimliOneCikanKonular:OneCikan';
		$structure->primaryKey = 'thread_id';
		$structure->columns = [
			'thread_id' =>				['type' => self::UINT, 'required' => true],
			'onecikan_tarih' =>			['type' => self::UINT, 'required' => true],
			'onecikan_zaman' =>			['type' => self::UINT, 'required' => true],
			'onecikan_baslik' =>		['type' => self::STR, 'required' => false, 'default' => '', 'censor' => true],
			'onecikan_aciklama' =>		['type' => self::STR, 'required' => false, 'default' => '', 'censor' => true],
		];
		$structure->getters = [
			'image' => true,
		];
		$structure->relations = [
			'CatLink' => [
				'entity' => 'XenGenTr\ResimliOneCikanKonular:CatLink',
				'type' => self::TO_ONE,
				'conditions' => 'thread_id',
			],
			'Thread' => [
				'entity' => 'XF:Thread',
				'type' => self::TO_ONE,
				'conditions' => 'thread_id',
				'primary' => true,
			],
		];

		return $structure;
	}
}