<?php

namespace XenGenTr\ResimliOneCikanKonular\pub\Controller;

use XF\Pub\Controller\AbstractController;

class OneCikanlar extends AbstractController
{ 	

    public function actionIndex()
    {
        $visitor = \XF::visitor();
        if (!$visitor->canOnecikanGor())
        {
            throw $this->exception($this->noPermission());
        }

		$page = $this->filterPage();
		$perPage = $this->options()->xgt_onecikankonu_sayfabasi_konu;

        /** @var \XenGenTr\ResimliOneCikanKonular\Repository\OneCikan $repo */
		$onecikanRepo = $this->app->repository('XenGenTr\ResimliOneCikanKonular:OneCikan');

		$entries = $onecikanRepo->findOnecikan();
	    $entries->limitByPage($page, $perPage);

		if (!$onecikanlar = $entries->fetch())
		{
			return false;
		}
		
			$viewParams = [
				'onecikanlar' => $entries->fetch(),
			    'total' => $entries->total(),
			    'page' => $page,
			    'perPage' => $perPage,
		];

        return $this->view('XenGenTr\ResimliOneCikanKonular:OneCikan', 'xgt_OneCikan_Konular_listele', $viewParams);
    }
}